package hage;

/**
 * ...
 * @author JanGamesCo
 */
class HGEBasic
{
	/***Public vars***/
	/**Parent object reference*/
	public var parent:HGEBasic;
	/*Children objects*/
	/**
	 * TODO Optimize children and id assigment so remove can be constant
	 * and removed object id can be reasigned to newer objects
	 * Ideas: Usea queue for ids and generate new id if necesary, assign id using queue.
	 */
	public var childrens:Array<HGEBasic>;

	/**ID, unique for every object*/
	public var ID:Int;

	/**Flag for existance, object is updated if true*/
	public var exists:Bool;
	/**Flag for rendering, object is renderer on true*/
	public var visible:Bool;

	/***Public functions***/
	/**Init*/
	public function new():Void
	{
		//Get ID
		ID = HGE.getID();

		//Init vars
		parent = null;
		childrens = new Array();

		exists = true;
		visible = true;
	}
	
	/**Update function*/
	public function update():Void
	{
		//Update childrens
		for(child in childrens) {
			if(child.exists) { child.update(); }
		}

		return;
	}

	/**Draw function*/
	public function draw():Void
	{
		for(child in childrens) {
			if(child.exists) { child.draw(); }
		}
		
		return;
	}

	/**Game add basic function*/
	public function add(Child:HGEBasic):Void
	{
		Child.parent = this;
		childrens.push(Child);
	}

	/**Remove a basic function*/
	public function remove(Child:HGEBasic):Void
	{
		Child.parent = null;
		childrens.remove(Child);
	}
	
	/**Set the exists and visible flags of the object to false*/
	public function kill():Void
	{
		exists = false;
		visible = false;
	}
	
	/**Set the exists and visible flags of the object to true*/
	public function revive():Void
	{
		exists = true;
		visible = true;
	}
	
	/**Destroy the current object (Deleteting all the references)*/
	public function destroy():Void
	{
		exists = false;
		visible = false;
		parent = null;
		childrens = null;
	}
	
	/**Reset current object*/
	public function reset():Void
	{
		childrens = new Array();
		revive();
		
		return;
	}

}