package hage;
import hage.HGEData.SpriteSide;
import kha.Color;
import kha.math.FastMatrix3;

/**
 * ...
 * @author JanGamesCo
 */
class HGESprite extends HGEBasic
{
	/***Public vars***/
	/** Alpha */
	public var alpha(get, set):Float;
	/** Position */
	public var x:Float;
	public var lastX:Float;
	public var y:Float;
	public var lastY:Float;
	/** Width */
	public var width:Float;
	/** Height */
	public var height:Float;
	/** ScaleX */
	public var scaleX(default, set):Float;
	/** ScaleY */
	public var scaleY(default, set):Float;
	
	/***Private vars***/
	/** HGE draw matrix */
	private var matrix:FastMatrix3;
	/** Sprite color */
	private var color:Color;
	
	/** Create a new sprite */
	public function new(X:Float=0, Y:Float=0, Width:Float=0, Height:Float=0, ColorV:UInt=null, Alpha:Float=1)
	{
		super();
		
		//Set position
		x = X;
		y = Y;
		
		//Set width and height
		width = Width;
		height = Height;
		
		//Color
		color = Color.fromValue(ColorV);
		
		//Alpha
		alpha = Alpha;
		
		//Init matrix
		matrix = new FastMatrix3(1, 0, 0, 0, 1, 0, 0, 0, 1);
		
		//Scale
		scaleX = 1;
		scaleY = 1;
	}
	
	/***Public functions***/
	/**  */
	
	/**  */
	public function aabb(Other:HGESprite):Bool
	{		
		if (Other.exists && exists &&
			x < Other.x + Other.width &&
			x + width > Other.x &&
			y < Other.y + Other.height &&
			y + height > Other.y) {
			return true;
		}
		
		return false;
	}
	
	/**  */
	public function sidedaabb(Other:HGESprite):SpriteSide
	{		
		if (Other.exists && exists &&
			x < Other.x + Other.width &&
			x + width > Other.x &&
			y < Other.y + Other.height &&
			y + height > Other.y) {
			
			var lx = lastX + width;
			var ly = lastY + height;
			
			if (lx < Other.x) {
				return SpriteSide.LEFT;
			} else if (lastX > Other.x + Other.width) {
				return SpriteSide.RIGHT;
			} else if (ly < Other.y) {
				return SpriteSide.UP;
			} else {
				return SpriteSide.DOWN;
			}
		}
		
		return SpriteSide.NONE;
	}
	
	/***Overrides***/
	/** Update method */
	override public function update():Void
	{
		super.update();
		
		//Get last x and y
		lastX = x;
		lastY = y;
	}
	
	/** Draw Method */
	override public function draw():Void
	{
		super.draw();
		
		HGE.backbuffer.g2.set_color(color);
		HGE.backbuffer.g2.fillRect(x, y, width, height);
	}
	
	/***Getters and setters***/
	private function get_alpha():Float { return 0; }
	private function set_alpha(Value:Float):Float { return 0; }
	
	private function set_scaleX(Value:Float):Float { return scaleX = matrix._00 = Value; }
	private function set_scaleY(Value:Float):Float { return scaleY = matrix._11 = Value; }
}