package hage;

import hage.HGEData.TextAlign;
import kha.math.FastMatrix3;
import kha.Scaler;

import kha.Color;
import kha.Font;

/**
 * ...
 * @author JanGamesCo
 */
class HGEText extends HGESprite
{	
	/***Public vars***/
	/** Text font */
	public var font:Font;
	/** Set and get text */
	public var text(default, set):String;
	/** Text width */
	public var textWidth:Float;
	/** Text align */
	public var aling:TextAlign;
	
	/***Private vars***/

	public function new(X:Float, Y:Float, Size:Float, FontVal:Font, ColorV:UInt = 0xFFFFFFFF, Alpha:Float = 1) 
	{		
		super(X, Y, 1, 1, ColorV, Alpha);
		
		//Setup font
		font = FontVal;
	}
	
	/*Center text*/
	public function setAlign(Align:TextAlign, Width:Float):Void
	{
		aling = Align;
		width = Width;
	}
	
	/*Draw function*/
	private var drawx:Float = 0;
	override public function draw():Void
	{
		HGE.backbuffer.g2.set_color(color);
		HGE.backbuffer.g2.font = font;
		switch (aling) 
		{
			case TextAlign.CENTER:
				drawx = x + Math.floor((width - textWidth * scaleX) / 2);
			default:
				drawx = x;
		}
		matrix._20 = drawx;
		matrix._21 = y;
		
		HGE.backbuffer.g2.pushTransformation(matrix);
		HGE.backbuffer.g2.drawString(text, 0, 0);
		HGE.backbuffer.g2.popTransformation();
		
		return;
	}
	
	/***Getters and setters***/
	private function set_text(Value:String):String {
		text = Value;
		textWidth = font.stringWidth(text);
		
		return text;
	}
	
}