package hage;

/**
 * ...
 * @author JanGames
 */
class HGEVector2
{
	/***Public vars***/
	public var x:Float;
	public var y:Float;	
	
	/***Public functions***/
	public function new(X:Float = 0, Y:Float = 0) 
	{
		x = X;
		y = Y;
	}
	
	//Simple vector addition
	public function add(Other:HGEVector2):Void
	{
		x += Other.x;
		y += Other.y;
	}
	
	//Dot product
	public function dot(Other:HGEVector2):Float
	{
		return x * Other.x + y * Other.y;
	}
	
	//Vector multiplication by scalar
	public function mul(Value:Float):Void
	{
		x *= Value;
		y *= Value;
	}
	
	//Rotate vector by an angle in radians
	public function rotate(Value:Float):Void
	{
		var X:Float = x;
		x = x * Math.cos(Value) - y * Math.sin(Value);
		y = X * Math.sin(Value) + y * Math.cos(Value);
	}
	
	//Vector magnitude
	public function magnitude():Float
	{
		return Math.sqrt(x * x + y * y);
	}
	
	//Vector set
	public inline function set(X:Float, Y:Float):Void
	{
		x = X;
		y = Y;
	}
}